//------------------------------------------------------------------------------
//            Project.Anything
//------------------------------------------------------------------------------

unit uCRT; // ConsoleRunTime

interface

uses Windows;

const UnitVersion = '1.1';
      UnitDate = '31 jul 2007';

//------------------------------------------------------------------------------
//       Windows.
//
// Best Regards,
//               [ DnX ].Dragon;
//                               10 may 2006
//------------------------------------------------------------------------------
// WorkAround:    ,
//   " "    .
// TODO : Event-Filter; Mouse::Scrolls, etc.; Keyboard::State, etc. 

//------------------------------------------------------------------------------
//            DOS-Pascal-CRT-like functions & Constants
//------------------------------------------------------------------------------

Function ClrScr: Bool;
Function ClrEOL: Bool;
Function WhereX: Word;
Function WhereY: Word;
Function GotoXY(X, Y: Word): Bool;
Function TextColor(Color: Byte): Bool;
Function TextBackGround(Color: Byte): Bool;

// DOS-Like Colors
Const
      // Dark Colors:
      // (Foreground & Background)
      Black        =  0; // Black
      Blue         =  1; // Navy
      Green        =  2; // Green
      Cyan         =  3; // Teal
      Red          =  4; // Maroon
      Magenta      =  5; // Purple
      Brown        =  6; // Olive
      LightGray    =  7; // Silver

      // Light Colors:
      // (Foreground)
      DarkGray     =  8; // Gray
      LightBlue    =  9; // Blue
      LightGreen   = 10; // Lime
      LightCyan    = 11; // Aqua
      LightRed     = 12; // Red
      LightMagenta = 13; // Fuchsia
      Yellow       = 14; // Yellow
      White        = 15; // White

//------------------------------------------------------------------------------
//            ASCII Control Codes
//------------------------------------------------------------------------------

// -- Short - Num - Long Name -------------------- Key Const ------- Additive Consts

Const
      ccNUL = #$00; ccNull                = ccNUL; { Ctrl + @ }      ccEndOfString = ccNUL;
      ccSOH = #$01; ccStartOfHeading      = ccSOH; keyCtrlA = ccSOH;
      ccSTX = #$02; ccStartOfText         = ccSTX; keyCtrlB = ccSTX;
      ccETX = #$03; ccEndOfText           = ccETX; keyCtrlC = ccETX;
      ccEOT = #$04; ccEndOfTransmission   = ccEOT; keyCtrlD = ccEOT;
      ccENQ = #$05; ccEnquiry             = ccENQ; keyCtrlE = ccENQ;
      ccACK = #$06; ccAcknowledge         = ccACK; keyCtrlF = ccACK;
      ccBEL = #$07; ccBell                = ccBEL; keyCtrlG = ccBEL;
      ccBS  = #$08; ccBackSpace           = ccBS ; keyCtrlH = ccBS ;                 keyBackSpace = ccBS;
      ccHT  = #$09; ccHorizontalTab       = ccHT ; keyCtrlI = ccHT ; ccTAB = ccHT;   keyTAB = ccHT;
      ccLF  = #$0A; ccLineFeed            = ccLF ; keyCtrlJ = ccLF ;                 keyEnter = ccLF;
      ccVT  = #$0B; ccVerticalTab         = ccVT ; keyCtrlK = ccVT ;
      ccFF  = #$0C; ccFormFeed            = ccFF ; keyCtrlL = ccFF ;
      ccCR  = #$0D; ccCarriageReturn      = ccCR ; keyCtrlM = ccCR ;
      ccSO  = #$0E; ccShiftOut            = ccSO ; keyCtrlN = ccSO ;
      ccSI  = #$0F; ccShiftIn             = ccSI ; keyCtrlO = ccSI ;
      ccDLE = #$10; ccDataLineEscape      = ccDLE; keyCtrlP = ccDLE;
      ccDC1 = #$11; ccDeviceCtrl1         = ccDC1; keyCtrlQ = ccDC1; ccXON = ccDC1;
      ccDC2 = #$12; ccDeviceCtrl2         = ccDC2; keyCtrlR = ccDC2;
      ccDC3 = #$13; ccDeviceCtrl3         = ccDC3; keyCtrlS = ccDC3; ccXOFF = ccDC3;
      ccDC4 = #$14; ccDeviceCtrl4         = ccDC4; keyCtrlT = ccDC4;
      ccNAK = #$15; ccNegativeAcknowledge = ccNAK; keyCtrlU = ccNAK;
      ccSYN = #$16; ccSynchronousIdle     = ccSYN; keyCtrlV = ccSYN;
      ccETB = #$17; ccEndTransmitBlock    = ccETB; keyCtrlW = ccETB;
      ccCAN = #$18; ccCancel              = ccCAN; keyCtrlX = ccCAN;
      ccEM  = #$19; ccEndOfMedium         = ccEM ; keyCtrlY = ccEM ;
      ccSUB = #$1A; ccSubstitute          = ccSUB; keyCtrlZ = ccSUB;
      ccESC = #$1B; ccEscape              = ccESC; { Ctrl + [ }                      keyEscape = ccESC;
      ccFS  = #$1C; ccFileSeparator       = ccFS ; { Ctrl + \ }
      ccGS  = #$1D; ccGroupSeparator      = ccGS ; { Ctrl + ] }
      ccRS  = #$1E; ccRecordSeparator     = ccRS ; { Ctrl + ^ }
      ccUS  = #$1F; ccUnitSeparator       = ccUS ; { Ctrl + _ }

//------------------------------------------------------------------------------
//            Native Color Type
//------------------------------------------------------------------------------

type
     TConsoleColor =
       (cclBlack, cclNavy, cclGreen, cclTeal, cclMaroon, cclPurple, cclOlive, cclSilver,
        cclGray, cclBlue, cclLime, cclAqua, cclRed, cclFuchsia, cclYellow, cclWhite);

     TKeyEventRecord = Windows.TKeyEventRecord;
     TInputRecord = Windows.TInputRecord;

//------------------------------------------------------------------------------
//            Native functions
//------------------------------------------------------------------------------

Function ReadEvent: TInputRecord;
Function ReadKeyEvent: TKeyEventRecord;
Function ReadKeyPressedEvent: TKeyEventRecord;
Function ReadKeyPressedEventEx: TKeyEventRecord;
Function ReadKey: Char;
Function ReadVKey: Word;

Function GetMousePosition: TCoord;

Function ClearScreen: Bool;
Function ClearEOL: Bool;

Function GetTextAttr: Word;
Function GetTextColor: Byte;
Function GetTextBackGround: Byte;
Function GetCursorVisible: Bool;
Function GetCursorHeight: Byte;
Function GetTitle: String;
Function GetScreenBufferSize: TCoord;
Function GetCursorPosition: TCoord;

Function ConsoleColor(Color: TConsoleColor): Byte;

Function SetTextAttr(Attr: Word): Bool;
Function SetTextColor(Color: TConsoleColor): Bool;      OverLoad;
Function SetTextBackGround(Color: TConsoleColor): Bool; OverLoad;
Function SetTextColor(Color: Byte): Bool;               OverLoad;
Function SetTextBackGround(Color: Byte): Bool;          OverLoad;
Function SetCursorVisible(Visible: Bool): Bool;
Function SetCursorHeight(Height: Byte): Bool;
Function SetTitle(Title: String): Bool;
Function SetScreenBufferSize(X, Y: Word): Bool;
Function SetCursorPosition(X, Y: Word): Bool;

//------------------------------------------------------------------------------
              implementation
//------------------------------------------------------------------------------
(*
//  (Delphi < 7)
{$IFDEF SysUtils}
uses SysUtils;
{$ELSE}
{
       
  SysUtils , ,  
 .      25 
       
 .
}

type
  TTextRec = record
    Handle: Integer;
    Mode: Integer;
    BufSize: Cardinal;
    BufPos: Cardinal;
    BufEnd: Cardinal;
    BufPtr: PChar;
    OpenFunc: Pointer;
    InOutFunc: Pointer;
    FlushFunc: Pointer;
    CloseFunc: Pointer;
    UserData: array[1..32] of Byte;
    name: array[0..259] of Char;
    Buffer: array[0..127] of Char;
end;
{$ENDIF}
*)

//------------------------------------------------------------------------------
//            Misc
//------------------------------------------------------------------------------

var
    hConOut, hConIn: LongWord;
    MousePosition: TCoord;

function ConOutFunc(var Text: TTextRec): Integer;
var
  Dummy: Cardinal;
  SavePos: Integer;
begin
  SavePos := Text.BufPos;
  if SavePos > 0 then
  begin
    Text.BufPos := 0;
    CharToOemBuff(Text.BufPtr, Text.BufPtr, SavePos);
    if WriteFile(Text.Handle, Text.BufPtr^, SavePos, Dummy, nil) then
      Result := 0
    else
      Result := GetLastError;
  end
  else
    Result := 0;
end;

//------------------------------------------------------------------------------
//            DOS-Like
//------------------------------------------------------------------------------

Function ClrScr: Bool; begin Result := ClearScreen; End;
Function ClrEOL: Bool; begin Result := ClearEOL; End;
Function WhereX: Word; begin Result := GetCursorPosition.X; End;
Function WhereY: Word; begin Result := GetCursorPosition.Y; End;
Function GotoXY(X, Y: Word): Bool; begin Result := SetCursorPosition(X, Y); End;
Function TextColor(Color: Byte): Bool; begin Result := SetTextColor(Color); End;
Function TextBackGround(Color: Byte): Bool; begin Result := SetTextBackGround(Color); End;

//------------------------------------------------------------------------------
//            Unit Routines
//------------------------------------------------------------------------------

Function ReadEvent: TInputRecord;
var
    IEvent: DWord;
begin
  ReadConsoleInput(hConIn, Result, 1, IEvent);
  if (Result.EventType = _MOUSE_EVENT) and
     (Result.Event.MouseEvent.dwEventFlags = MOUSE_MOVED) then
    MousePosition := Result.Event.MouseEvent.dwMousePosition;
{
  Mouse Scroll is in MouseEvent.dwButtonState;
  Scroll 1 (V):
  FF880000 - Scrolls down (-120) 120 = WHEEL_DELTA_V (or just WHEEL_DELTA)
  00780000 - Scrolls up   (+120)
  Scroll 2 (H):
  FFF00000 - Scrolls down (-16) 16 = WHEEL_DELTA_H
  00100000 - Scrolls up   (+16)
}
End;

Function ReadKeyEvent: TKeyEventRecord;
var Event: TInputRecord;
begin
  Event := ReadEvent;
  While (Event.EventType <> KEY_EVENT) do
    Event := ReadEvent;
  Result := Event.Event.KeyEvent;
End;

Function ReadKeyPressedEvent: TKeyEventRecord;
var Event: TKeyEventRecord;
begin
  Event := ReadKeyEvent;
  While (not Event.bKeyDown) do
    Event := ReadKeyEvent;
  Result := Event;
End;

Function ReadKeyPressedEventEx: TKeyEventRecord;
var Event: TKeyEventRecord;
begin
  Event := ReadKeyPressedEvent;
  While (Event.wVirtualKeyCode = VK_MENU) or
        (Event.wVirtualKeyCode = VK_LMENU) or
        (Event.wVirtualKeyCode = VK_RMENU) or
        (Event.wVirtualKeyCode = VK_SHIFT) or
        (Event.wVirtualKeyCode = VK_LSHIFT) or
        (Event.wVirtualKeyCode = VK_RSHIFT) or
        (Event.wVirtualKeyCode = VK_CONTROL) or
        (Event.wVirtualKeyCode = VK_LCONTROL) or
        (Event.wVirtualKeyCode = VK_RCONTROL) do
    Event := ReadKeyPressedEvent;
  Result := Event;
End;

Function ReadKey: Char;
var Event: TKeyEventRecord;
begin
  Event := ReadKeyPressedEvent;
  While (Event.AsciiChar = #0) do
    Event := ReadKeyPressedEvent;

  Result := Event.AsciiChar;
End;

Function ReadVKey: Word;
begin
  Result := ReadKeyPressedEvent.wVirtualKeyCode;
End;

Function GetMousePosition: TCoord;
begin
  Result := MousePosition;
End;

Function ClearScreen: Bool;
const
  UpperLeft: TCoord = (X: 0; Y: 0);
var
  Len: DWord;
begin
  With GetScreenBufferSize do
    begin
      FillConsoleOutputCharacter(hConOut, #32, X*Y, UpperLeft, Len);
      FillConsoleOutputAttribute(hConOut, GetTextAttr, X*Y, UpperLeft, Len);
    End;
  Result := SetCursorPos(0, 0);
end;

Function ClearEOL: Bool;
var
  Len: DWord;
begin
  Len := GetScreenBufferSize.X - GetCursorPosition.X;
  FillConsoleOutputCharacter(hConOut, #32, Len, GetCursorPosition, Len);
  Len := GetScreenBufferSize.X - GetCursorPosition.X;
  Result := FillConsoleOutputAttribute(hConOut, GetTextAttr, Len, GetCursorPosition, Len);
End;

Function GetTextAttr: Word;
var Info: _CONSOLE_SCREEN_BUFFER_INFO;
begin
  GetConsoleScreenBufferInfo(hConOut, Info);
  Result := Info.wAttributes;
End;

Function GetTextColor: Byte;
begin
  Result := GetTextAttr and $F;
End;

Function GetTextBackGround: Byte;
begin
  Result := GetTextAttr and $F0 shr 4;
End;

Function GetCursorVisible: Bool;
var Info: _CONSOLE_CURSOR_INFO;
begin
  GetConsoleCursorInfo(hConOut, Info);
  Result := Info.bVisible;
End;

Function GetCursorHeight: Byte;
var Info: _CONSOLE_CURSOR_INFO;
begin
  GetConsoleCursorInfo(hConOut, Info);
  Result := Info.dwSize;
End;

Function GetTitle: String;
begin
  SetLength(Result, MAX_PATH);
  SetLength(Result, GetConsoleTitle(PChar(Result), Length(Result)));
End;

Function GetScreenBufferSize: TCoord;
var Info: _CONSOLE_SCREEN_BUFFER_INFO;
begin
  GetConsoleScreenBufferInfo(hConOut, Info);
  Result := Info.dwSize;
End;

Function GetCursorPosition: TCoord;
var Info: _CONSOLE_SCREEN_BUFFER_INFO;
begin
  GetConsoleScreenBufferInfo(hConOut, Info);
  Result := Info.dwCursorPosition;
End;

Function ConsoleColor(Color: TConsoleColor): Byte;
begin
  Result := Byte(Color);
End;

Function SetTextAttr(Attr: Word): Bool;
begin
  Result := SetConsoleTextAttribute(hConOut, Attr);
end;

Function SetTextColor(Color: TConsoleColor): Bool;
begin
  Result := SetTextColor(Byte(Color));
End;

Function SetTextBackGround(Color: TConsoleColor): Bool;
begin
  Result := SetTextBackGround(Byte(Color));
End;

Function SetTextColor(Color: Byte): Bool;
begin
  Result := SetTextAttr(GetTextAttr and $FFF0 or Color);
End;

Function SetTextBackGround(Color: Byte): Bool;
begin
  Result := SetTextAttr(GetTextAttr and $FF0F or Color shl 4);
End;

Function SetCursorVisible(Visible: Bool): Bool;
var Info: _CONSOLE_CURSOR_INFO;
begin
  GetConsoleCursorInfo(hConOut, Info);
  Info.bVisible := Visible;
  Result := SetConsoleCursorInfo(hConOut, Info);
End;

Function SetCursorHeight(Height: Byte): Bool;
var Info: _CONSOLE_CURSOR_INFO;
begin
  GetConsoleCursorInfo(hConOut, Info);
  Info.dwSize := Height;
  Result := SetConsoleCursorInfo(hConOut, Info);
End;

Function SetTitle(Title: String): Bool;
begin
  Result := SetConsoleTitle(PChar(Title));
End;

Function SetScreenBufferSize(X, Y: Word): Bool;
var Size: TCoord;
begin
  Size.X := X;
  Size.Y := Y;
  Result := SetConsoleScreenBufferSize(hConOut, Size);
End;

Function SetCursorPosition(X, Y: Word): Bool;
var Size: TCoord;
begin
  Size.X := X;
  Size.Y := Y;
  Result := SetConsoleCursorPosition(hConOut, Size);
End;

//------------------------------------------------------------------------------
//            Initialization
//------------------------------------------------------------------------------

initialization
  ReWrite(OutPut); //   
  {   .    - 
  ,     }
  TTextRec(OutPut).InOutFunc := @ConOutFunc;
  TTextRec(OutPut).FlushFunc := @ConOutFunc;

  hConOut := GetStdHandle(STD_OUTPUT_HANDLE);
  hConIn := GetStdHandle(STD_INPUT_HANDLE);
end.
